// JavaScript Document
function Cgame(width,gameDivId){
	var status=false;
	var stage,kayakDown,gameOver;
	var LoadedResources=false;
	this.gameContainerId=gameDivId;
	var folderMain=homeURL+'js/games/kayak/';
	//current game
	var Difficulty=0;//0,1,2
	var LevelCount=0;//number of typed words in the current level
	var currentSpeech=0;
	var currentGame;//contains the current game's randomized words
	var clientWidth=0,clientHeight=0;
	
	var m_w = 123456789;
	var m_z = 987654321;
	var mask = 0xffffffff;
	var game=this;

	function seed(i){m_w = i%100000000;}

	function Random(){
	    m_z = (36969 * (m_z & 65535) + (m_z >> 16)) & mask;
    	m_w = (18000 * (m_w & 65535) + (m_w >> 16)) & mask;
	    var result = ((m_z << 16) + m_w) & mask;
    	result/=4294967296;
		result+=0.5;
	    return(result);
	}
	
	function Load(){
		this.score=false;this.Level=0;this.virtualScore=0;this.gameTime=0;
		status='loading';
		this.mute=false;
		this.config=new Cconfig(width);
		this.render=new Crender(game,this);
		this.UI=new Cui(game,this);
		this.startLoad=false;
		this.DrawInterval=setInterval(run,config.renderSpeed);
		this.startTime=false;
		this.challenge=false;
		this.AIOponent=false;
		this.AIPos={};
		this.WordScore=0;
		var obj=document.getElementById(gameDivId);
		if(obj){
			clientWidth=obj.clientWidth;
			clientHeight=obj.clientHeight;
		}
	}
	

	function onUILoaded(){
		if(this.startLoad)return;
		this.startLoad=true;
		this.render.preload();
		this.audio=new Array();
		this.currentChannel=0;
		this.audio[0]=new Caudio(this);
		this.audio[1]=new Caudio(this);
		
		var snd;
		snd='fail';this.soundFail=new Caudio(this);this.soundFail.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		snd='Game over';this.soundGameOver=new Caudio(this);this.soundGameOver.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		snd='level complete';this.soundLevelComplete=new Caudio(this);this.soundLevelComplete.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		snd='new record';this.soundNewRecord=new Caudio(this);this.soundNewRecord.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		snd='Sentence';this.soundSentence=new Caudio(this);this.soundSentence.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		snd='Stream';this.soundStream=new Caudio(this);this.soundStream.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');this.soundStream.sound.loop=true;	
		snd='warning';this.soundWarning=new Caudio(this);this.soundWarning.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		
		ajaxGetStr(folderMain+'config/config.json',LoadConfig,this);
	}
	
	function LoadConfig(str){
		this.config.fileConfig=JSON.parse(str);
		startGSP(this.config.fileConfig.loginPeriod,game);
		LoadedResources=false;
	}

	function LoadElements(str){
		var i,level;
		var sounds=JSON.parse(str);
		var maxLevel;
//		if('undefined' !== typeof LoadedResources)delete(LoadedResources);
		LoadedResources=new Array();
		for(i=0;i<sounds.length;i++){
			level=parseInt(sounds[i][1])-1;
			if(!LoadedResources[level])LoadedResources[level]=new Array();
			maxLevel=LoadedResources[level].length;
			LoadedResources[level][maxLevel]=[sounds[i][0],sounds[i][2],sounds[i][3]];
		}
		this.startGameAudio(Difficulty);
		AIPos.currentWord=0;
		AIPos.playerWord=0;
		AIPos.time=0;
		AIPos.AIScore=0;
		AIPos.AIwords=new Array();
		var Smin=config.fileConfig.Topics[Difficulty].DifficultyLevels[Level].ComputerMinim;
		var Smax=config.fileConfig.Topics[Difficulty].DifficultyLevels[Level].ComputerMaxim;
		for(i=0;i<currentGame.words.length;i++){
			percent=Smin+Math.random()*(Smax-Smin);
			AIPos.AIwords[i]=(Math.floor(currentGame.words[i]*percent))*config.scorePerLetter;
			AIPos.AIScore+=AIPos.AIwords[i];
		}
	}
	
	function LoadOK(){
		if(!this.soundFail.ready())return(false);
		if(!this.soundGameOver.ready())return(false);
		if(!this.soundLevelComplete.ready())return(false);
		if(!this.soundNewRecord.ready())return(false);
		if(!this.soundSentence.ready())return(false);
		if(!this.soundStream.ready())return(false);
		if(!this.soundWarning.ready())return(false);
		if(!render.LoadOK())return(false);
		if(!this.config.fileConfig)return(false);
		var obj=document.getElementById(gameDivId);
		if(obj)obj.style.background='#fff';
		return(true);
	}

	function countWords(str){
		var count = 0,i;
		for (i=0;i<str.length;i++)if(str.charAt(i)==" ")count++;
		return(count+1);  
	}
	
	function getWords(str){
		str=str.toLocaleLowerCase();
		var ret=new Array();
		var pos=0,count,i,j;
		for(i=0;i<str.length;i++)if(str.charAt(i)==" " || i==str.length-1){
			count=0;
			for(j=pos;j<=i;j++)if((str[j]>='a' && str[j]<='z') || str[j]=="'")count++;
			ret[ret.length]=count;
			pos=i+1;
		}
		return(ret);  
	}
	
	this.startGameAudio=function(diff){
		var i,a,b,c=0,d,ln,pick,picked=new Array(),words=false;
		if(currentGame)currentGame.length=0;
		else currentGame=new Array();
		currentGame.wordCount=0;
		if(currentGame.words)currentGame.words.length=0;
		else currentGame.words=new Array();
		a=new Date().getTime();
		seed(a);
		for(a=0;a<LoadedResources.length;a++){//each level
			config.setLevel(diff,a);
			currentGame[a]=new Array();
			ln=LoadedResources[a].length;//total resources for level [a]
			for(b=0;b<ln;b++)picked[b]=false;
			for(b=0;b<config.ElementNum;b++){
				if(challenge){
					currentGame[a][b]=challenge.words[c];
				}else{
					pick=Math.floor(Random()*ln);
					d=0;
					for(i=0;i<LoadedResources[a].length;i++)if(!picked[i]){
						if(d>=pick)break;
						else d++;
					}
					currentGame[a][b]=i;
					picked[i]=true;
					ln--;
					if(ln<=0)ln=LoadedResources[a].length;
				}
				this.gameRecord.words[c]=currentGame[a][b];c++;
				currentGame.wordCount+=countWords(LoadedResources[a][currentGame[a][b]][0]);
				if(words)words.length=0;words=getWords(LoadedResources[a][currentGame[a][b]][0]);
				for(i=0;i<words.length;i++)currentGame.words[currentGame.words.length]=words[i];
			}
		}
		currentGame.upRiver=1.0/currentGame.wordCount;
		config.upRiver=currentGame.upRiver;
		game.newWord();
		audio[currentChannel].LoadSound(currentSpeech[1],currentSpeech[2]);
		audio[currentChannel].PlayThrough=true;
	}
	
	this.newGame=function(diff){
		LoadedResources=false;
		this.gameRecord={
			difficulty:diff,
			words:[],
			completed:[]
		};
		config.setLevel(diff,0);
		Difficulty=diff;
		Level=-1;WordScore=0;score=0;virtualScore=0;gameTime=0;LevelCount=0;
		LevelStr=config.fileConfig.Topics[Difficulty].name;

		
		currentChannel=0;
		stage=0.0;
		kayakDown=0.0;
		gameOver=false;
		
		var background=render.Start();
		var snd=config.fileConfig.Screens[background].BackroundSound;
		soundStream.LoadSound(folderMain+'assets/sound/ui/'+snd+'.mp3',folderMain+'assets/sound/ui/'+snd+'.ogg');
		startTime=false;
		ajaxGetStr(config.fileConfig.Topics[diff].elmenetsUrl,LoadElements,this);
		config.setLevel(diff,0);
	}
	
	this.newWord=function(){
		if(gameOver)return;
		score=virtualScore;
		status='starting';
		if(LevelCount>=config.ElementNum || Level<0){
			Level++;
			LevelCount=0;
			UI.hintCount=0;
			if(Level>=LoadedResources.length){//victory
				status='playing';
				gameOver=true;
				return;
			}else if(Level){
				UI.startTime=time;
				status='newLevel';
				soundLevelComplete.Play();
			}
			config.setLevel(Difficulty,Level);
		}/*else
			if(LevelCount>0)soundSentence.Play();*/
		currentSpeech=config.loadResource(LoadedResources[Level][currentGame[Level][LevelCount]]);
		currentSpeech[0]=currentSpeech[0].toLocaleLowerCase();
		var str='';
		for(i=0;i<currentSpeech[0].length;i++)if((currentSpeech[0][i]>='a' && currentSpeech[0][i]<='z')|| currentSpeech[0][i]==' ' || currentSpeech[0][i]=="'"){
			str=str.concat(currentSpeech[0][i]);
		}
		currentSpeech[0]=str;
		//alert(str);
		currentSpeech.letter=0;
		var input=document.getElementById('gameInput');
		if(input){
			input.value='';
			input.focus();
		}
		LevelCount++;
		
		wrongKey=false;
		
		if(currentChannel>0)currentChannel=0;else currentChannel=1;
		
	}
	
	this.keyPress=function(evt){
		if(status!='playing')return(false);
		if(stage>1.0 || kayakDown>1.0)return(false);
		if(gameOver)return(false);

		  evt = evt || window.event;
		  var keyCode = evt.keyCode || evt.which;
		  var charCode = evt.charCode || keyCode;
		  var charStr = String.fromCharCode(charCode);
  
		if(status!='playing')return;
		var char=String.fromCharCode(evt.keyCode).toLocaleLowerCase();
		var cc=currentSpeech[0].charCodeAt(currentSpeech.letter);
		if(!char.localeCompare(currentSpeech[0].charAt(currentSpeech.letter)) || (currentSpeech[0].charCodeAt(currentSpeech.letter)==39 && keyCode==222)){
			//correct key pressed
			if(evt.keyCode!=32){
				if(!wrongKey)
					virtualScore+=config.scorePerLetter;
//					if(AIOponent===true)AIOponent=0;AIOponent+=config.scorePerLetter;
		}
			currentSpeech.letter++;
			wrongKey=false;
			if((evt.keyCode==32) || (currentSpeech.letter==currentSpeech[0].length)){//word completed
				AIPos.playerWord++;
				if(config.kayakUp){
					var count=0,a=currentSpeech.letter;
					if(evt.keyCode==32)a-=2;
					while(a>0){
						if(currentSpeech[0][a]!=' ')count++;else break;
						a--;
					}
					if(currentSpeech[0][a]!=' ')count++;
					if(currentSpeech.letter==currentSpeech[0].length)count--;
					WordScore=virtualScore;
					kayakDown-=count*config.kayakUp;
					if(kayakDown<0.0)kayakDown=0.0;
				}else
					kayakDown=0.0;
				stage+=currentGame.upRiver;if(stage>1.0)stage=1.0;
				this.gameRecord.completed[this.gameRecord.completed.length]=[gameTime,kayakDown,stage,virtualScore];//recording game
			}
			return(true);
		}
		if(evt.keyCode>=112 && evt.keyCode<=123)return true;
		if(evt.keyCode>=16 && evt.keyCode<=18)return true;
		if(evt.keyCode==13 || evt.keyCode==27)return true;
		//incorrect key pressed
		kayakDown+=config.kayakDown;
		soundFail.Play();
		wrongKey=true;
		this.gameRecord.completed[this.gameRecord.completed.length]=[gameTime,kayakDown,stage,virtualScore];//recording game
		if(kayakDown>1.0){//you loose
			kayakDown=1.0;
		}
		return(false);
	}
	
	
	function victory(){
		this.soundStream.sound.pause();
		status='game over';
		saveScore();
	}
	
	function defeat(){
		this.soundStream.sound.pause();
		status='game over'
		saveScore();
	}
	
	this.setStatus=function(Astatus){
		status=Astatus;
	}
	
	this.getScore=function(){
		return(score);
	}
	
	this.getchallenge=function(){
		return(challenge);
	}
	
	this.getchallengedPlayer=function(){
		return(challengedPlayer);
	}
	
	this.getgameRecord=function(){
		return(this.gameRecord);
	}
	
	this.setUIScreen=function(value){
		UI.screen=value;
	}
	
	this.getDifficulty=function(){
		return(Difficulty);
	}
	
	this.toogleSound=function(){
		var obj=document.getElementById('toogleSound');
		if(!obj)return;
		var i;
		if(mute){
			obj.src=folderMain+'assets/images/ui/sound icon.png';
			mute=false;
			soundStream.sound.muted=false;
			soundWarning.sound.muted=false;
			soundSentence.sound.muted=false;
			//for(i=0;i<audio.length;i++)audio[i].sound.muted=false;
		}else{
			obj.src=folderMain+'assets/images/ui/sound-off.png';
			mute=true;
			soundStream.sound.muted=true;
			soundWarning.sound.muted=true;
			soundSentence.sound.muted=true;
			//for(i=0;i<audio.length;i++)audio[i].sound.muted=true;
		}
	}
	
	this.publishScore=function(){
		if(GSP){
			GSP.getHighscores({}, function(status, data) {
				var highScore=false,rez,msg;
				for ( var i = 0; i < data.length; i++){
					var score=game.getScore();
					var currHighScore=parseInt(data[i].score);
					if(score>currHighScore)highScore=true;
				}
				if(highScore){
					msg=config.fileConfig.menuTexts.publishMessageHighScore;
					rez=msg.replace(/#score;/g,score);
				}else{
					msg=config.fileConfig.menuTexts.publishMessage;
					rez=msg.replace(/#score;/g,score);
				}
				GSP.statusPublish({"message" : rez});
			});
		}
		status='main menu';
	}
	
	this.drawGameOverBanner=function(isHighScore,playSound,skipDraw){
		if(playSound){
			if(isHighScore)
				soundNewRecord.Play();
			else
				soundGameOver.Play();
		}
		if(skipDraw)return;
		var canV=document.getElementById('bannerCanvas');
		if(!canV)return;
		var ctx=canV.getContext("2d");
		if(!ctx)return;
		ctx.clearRect(0,0,canV.width,canV.height);
		ctx.font = (24*config.aspectRatio)+'px "FolksHeavy"';
		ctx.fillStyle = '#fff';
		if(challenge && challenge.score<score)
			drawTextAlongArc(ctx,config.fileConfig.menuTexts.youWon,151*config.aspectRatio,425*config.aspectRatio,400*config.aspectRatio,Math.PI * 0.09);
		else if(challenge && challenge.score>score)
			drawTextAlongArc(ctx,config.fileConfig.menuTexts.youLost,151*config.aspectRatio,425*config.aspectRatio,400*config.aspectRatio,Math.PI * 0.085);
		else if(challenge && challenge.score==score)
			drawTextAlongArc(ctx,config.fileConfig.menuTexts.itsATie,151*config.aspectRatio,425*config.aspectRatio,400*config.aspectRatio,Math.PI * 0.09);
		else if(isHighScore)
			drawTextAlongArc(ctx,config.fileConfig.menuTexts.newHighScore,151*config.aspectRatio,425*config.aspectRatio,400*config.aspectRatio,Math.PI * 0.135);
		else
			drawTextAlongArc(ctx,config.fileConfig.menuTexts.gameOver,151*config.aspectRatio,425*config.aspectRatio,400*config.aspectRatio,Math.PI * 0.1);
	}
	
	this.setAI=function(value){
		AIOponent=value;
	}
	
	function runAI(){
		debugStr(config.fileConfig.menuTexts.youLost);
		var newW,i,percent;
		var delay=config.fileConfig.Topics[Difficulty].DifficultyLevels[Level].ComputerMaxDelay;
		var Wmax=config.fileConfig.Topics[Difficulty].DifficultyLevels[Level].ComputerMaxWordsDist;
		if(!AIPos.time){AIPos.time=this.time+Math.floor(Math.random()*5000);return;}
		if(this.time>AIPos.time){
			AIPos.time=this.time+Math.floor(Math.random()*delay);
			newW=this.AIPos.playerWord-Wmax+Math.floor(Math.random()*(Wmax*2+1));
			if(newW>currentGame.words.length-1)newW=currentGame.words.length-1;
			if(newW>this.AIPos.currentWord){//moving forward to newW
				if(AIOponent===true)AIOponent=0;
				for(i=this.AIPos.currentWord;i<=newW;i++){
//					percent=Smin+Math.random()*(Smax-Smin);
//					AIOponent+=(Math.floor(currentGame.words[i]*percent))*this.config.scorePerLetter;
					AIOponent+=AIPos.AIwords[i];
				}
				this.AIPos.currentWord=newW;
			}
		}
	}
	
	function resize(Pwidth,Pheight){
		clientWidth=Pwidth;
		clientHeight=Pheight;
		this.config.resize(clientWidth,clientHeight);
		var obj=document.getElementById('mainScreen');
		if(obj){
			obj.width=clientWidth;
			obj.height=clientHeight;
		}
		var obj=document.getElementById('ui_container');
		if(obj){
			obj.style.width=clientWidth+'px';
			//obj.style.marginLeft='-'+(clientWidth/2)+'px';
			obj.style.marginTop='-'+(clientHeight)+'px';
		}
		if(this.UI.screen!='gameScreen' && this.render.preloadedStart)this.render.drawRotPic(this.render.preloadedStart,0,0,this.config.aspectRatio,0.0,0,0);
		this.UI.screen='reload';
		
	}
	
	function run(){
		var date=new Date();
		var a,cw,ch;
		this.time=date.getTime();
		var obj=document.getElementById(gameDivId);
		if(obj){
			cw=obj.clientWidth;ch=obj.clientHeight;
			if(cw/ch>72/50)cw=ch*72/50;else ch=cw*50/72;
			if(clientWidth!=cw || clientHeight!=ch){
				resize(cw,ch);
			}
		}

		switch(status){
			case('loading'):
				if(!this.startLoad){
					if(UI.loaded())onUILoaded();
				}else{
					if(LoadOK()){
						status='main menu';
						render.Start();
						config.floatersDown=0.0;
						render.draw(0.0,0.0,true);
					}else UI.rotatePaddle();
				}
				break;
			case('main menu'):
				UI.drawMainMenu();
				break;
			case('difficulty menu'):
				UI.drawDifficultyMenu();
				break;
			case('starting'):
				if(audio[currentChannel].ready() && LoadedResources!==false && this.soundStream.ready()){
					if(!this.soundStream.playing){
						this.soundStream.sound.loop=true;
						this.soundStream.Play();
					}
					status='playing';
					this.audio[this.currentChannel].Play(0,true);
					this.soundStream.sound.volume=0.4;
					this.soundWarning.sound.volume=0.4;
					this.soundSentence.sound.volume=0.4;
					
					var nextLev=this.Level;
					var levCount=LevelCount;
					if(levCount>=this.config.ElementNum){
						nextLev++;levCount=0;
					}
					if(nextLev<LoadedResources.length){
						var next=config.loadResource(LoadedResources[nextLev][currentGame[nextLev][levCount]]);
						var chn=this.currentChannel;if(chn>0)chn=0;else chn=1;
						audio[chn].LoadSound(next[1],next[2]);
					}
				}
				else
					UI.drawLoadingScreen();
				this.buzzedOut=false;
				break;
			case('newLevel'):
				if(parseInt(this.time-UI.startTime)>parseInt(config.fileConfig.congratsScreenTimeOut)){
					status='starting';
				}else{
					UI.drawNewLevelScreen();
				}
				break;
			case('playing'):
				if(this.audio[this.currentChannel].sound.paused){
					this.soundStream.sound.volume=1.0;
					this.soundWarning.sound.volume=1.0;
					this.soundSentence.sound.volume=1.0;
				}
				if(!this.startTime)this.startTime=time;
				//this.gameTime+=config.renderSpeed;
				this.gameTime=this.time-this.startTime;
				if(Level>=LoadedResources.length){
					kayakDown=0.0;
					var Vlevel=LoadedResources.length-1;
					UI.drawGameScreen(LoadedResources[Vlevel][currentGame[Vlevel][0]][0]);
				}else{
					UI.drawGameScreen(LoadedResources[Level][currentGame[Level][LevelCount-1]][0]);
				}
				if(this.AIOponent)runAI();
//				if(Level>=LoadedResources.length && render.kayakOutOfBounds()){
				if(Level>=LoadedResources.length){
					status='finish line';
					//victory();
					break;
				}
				kayakDown+=config.riverSpeed;
				if(kayakDown>=1.0 && render.kayakOutOfBounds()){
					this.buzzedOut=true;
					if(this.challenge || this.AIOponent)status='finish line';else defeat();
					break;
				}
//				if(kayakDown>=1.0-config.kayakDown-config.riverSpeed*(500/config.renderSpeed)){
				if(kayakDown>=1.0-config.riverSpeed*(5000/config.renderSpeed)){
					if(!this.warned){this.soundWarning.Play();this.warned=true;}
				}else this.warned=false;
				render.draw(stage,kayakDown);
				if(currentSpeech.letter>=currentSpeech[0].length){
					status='between words';
					this.startBetween=this.time;
					this.soundSentence.Play();
//					game.newWord();
				}else if(!currentSpeech.letter){
					var input=document.getElementById('gameInput');if(input)input.value='';
				}
				break;
			case('between words'):
				render.draw(stage,kayakDown);
				if(this.time-this.startBetween>1000)game.newWord();
				//if(Level>=LoadedResources.length && render.kayakOutOfBounds()){
				if(Level>=LoadedResources.length){
					status='finish line';
					break;
				}
				break;
			case('finish line'):
				var Vlevel=LoadedResources.length-1;
				UI.drawGameScreen(LoadedResources[Vlevel][currentGame[Vlevel][0]][0]);
				render.draw(stage,-1.0,false);
				if(render.gameOver=='victory')victory();else if(render.gameOver=='defeat')defeat();
				break;
			case('game over'):
				this.AIOponent=false;
				UI.drawGameOver(stage);
				break;
			case('sign in'):
				UI.drawSignIn();
				break;
			case('high scores'):
				UI.drawHighScores();
				break;
			case('challenge mode'):
				UI.drawChallengeMode();
				break;
			case('add friends'):
				UI.drawAddFriends();
				break;
			case('challenge difficulty'):
				UI.drawChallengeDifficulty();
				break;
			case('accept challenge'):
				UI.acceptChallenge();
				break;
			case('game mode'):
				UI.drawGameMode();
				break;
		}
	}
	
	Load();
}
var drawBackground=-1;
function debugStr(str){
	var obj=document.getElementById('watchContainer');
	if(obj)obj.innerHTML=str;
}